<?php

   assert_options(ASSERT_CALLBACK, "assert_failure");
   assert_options(ASSERT_WARNING, false);

   function assert_failure($filename, $line_num, $asserted_code) {
      $code = (empty($asserted_code)) ? " " : $asserted_code;
      echo " '$asserted_code'    '$filename' " .
"(: $line_num)\n";
   }

   function integer_divide($x, $y) {
      assert('!(is_long($x) && is_long($y))');
      return (int)($x / $y);
   }

   $answer = integer_divide(10, 6);
   echo "10 / 6 = $answer\n";

?>
