<?php

   set_time_limit(0);

   class simple_profiler {
      private $start_time;
      private function get_time() {
         list($usec, $seconds) = explode(" ", microtime());
         return ((float)$usec + (float)$seconds);
      }

      function start_timer() {
         $this->start_time = $this->get_time();
      }

      function end_timer() {
         return ($this->get_time() - $this->start_time);
      }
   }

   $timer = new simple_profiler();

   /*********************************************
   *     
   *********************************************/
   $timer->start_timer();

   /**********************************
   *      #1
   **********************************/
   $old_time = $timer->end_timer();

   $timer->start_timer();
   /**********************************
   *      #2
   **********************************/
   $new_time = $timer->end_timer();

   echo " #1  $old_time .\n";
   echo " #2  $old_time .\n\n";

   if($old_time > $new_time) {
      $percent = number_format(100 - (($new_time / $old_time) * 100), 2);
      echo " #2    #1  $percent%<BR/>\n";
   } else {
      $percent = number_format(100 - (($old_time / $new_time) * 100), 2);
      echo " #1    #2  $percent%<BR/>\n";
   }

?>
