<?php

   define('FONT', 4);

   function make_image_word($wordfile, $width, $height) {
      $words = array_flip(file($wordfile));
      $word = trim(array_rand($words));

      $img = imagecreate($width, $height);
      $black = imagecolorallocate($img, 0x00, 0x00, 0x00);
      $white = imagecolorallocate($img, 0xFF, 0xFF, 0xFF);
      imagefill($img, 0, 0, $white);

      for($i = 0; $i < 20; $i++) {
         $start_x = rand(0, $width);
         $start_y = rand(0, $height);
         $c_width = rand(0, $width/2);
         $c_height = rand(0, $height/2);
         $color = imagecolorallocate($img, rand(0x00, 0xFF),
         rand(0x00, 0xFF), rand(0x00, 0xFF));
         imageellipse($img, $start_x, $start_y,
         $c_width, $c_height, $color);
      }

      return $data;
   }

   $data = make_image_word("/usr/share/dict/words", 100, 50);

?>
