<?php
declare(ticks = 1);
/*  ,   */
$signals = array(SIGHUP => "SIGHUP", SIGINT => "SIGINT",
SIGQUIT => "SIGQUIT", SIGILL => "SIGILL",
SIGTRAP => "SIGTRAP", SIGABRT => "SIGABRT",
SIGIOT => "SIGIOT", SIGBUS => "SIGBUS",
SIGFPE => "SIGFPE", SIGPROF => "SIGPROF",
SIGUSR1 => "SIGUSR1", SIGSEGV => "SIGSEGV",
SIGUSR2 => "SIGUSR2", SIGPIPE => "SIGPIPE",
SIGALRM => "SIGALRM", SIGTERM => "SIGTERM",
SIGSTKFLT => "SIGSTKFLT", SIGCLD => "SIGCLD",
SIGTTIN => "SIGTTIN", SIGTTOU => "SIGTTOUT",
SIGURG => "SIGURG", SIGXCPU => "SIGXCPU",
SIGXFSZ => "SIGXFSZ", SIGVTALRM => "SIGVTALRM",
SIGWINCH => "SIGWINCH", SIGPOLL => "SIGPOLL",
SIGIO => "SIGIO", SIGPWR => "SIGPWR",
SIGSYS => "SIGSYS", SIGBABY => "SIGBABY");
/*      */
function parent_signal_handler($signal_id) {
global $signals;
$pid = posix_getpid();
$time = date("h:i:s");
echo "$time:   {$signals[$signal_id]}..\n";
}
/*      */
function child_signal_handler($signal_id) {
global $signals;
$ppid = posix_getppid();
$time = date("h:i:s");
echo "$time:     " .
"{$signals[$signal_id]}..\n";
/*   SIGUSR1  ,  
   SIGTERM  SIGUSR1 */
switch ($signal_id) {
case SIGTERM:
case SIGUSR1:
echo " ..\n";
posix_kill($ppid, SIGUSR1);
exit;
}
}
/*   */
$child = pcntl_fork();
if($child == -1) {
die("    .");
}
if($child) { /*  -   */
$pid = posix_getpid();
/*      */
foreach($signals as $sig => $sig_str) {
@pcntl_signal($sig, "parent_signal_handler");
}
/*  5 ,    SIGUSR2   */
sleep(5);
posix_kill($child, SIGUSR2);
/*   5     SIGUSR1   */
sleep(5);
posix_kill($child, SIGUSR1);
/*     */
pcntl_waitpid($child, $status);
echo "  .\n";
} else { /*  -   */
/*      */
foreach($signals as $sig => $sig_str) {
@pcntl_signal($sig, "child_signal_handler");
}
$ppid = posix_getppid();
/*     SIGUSR2    */
while(1) {
sleep(3);
posix_kill($ppid, SIGUSR2);
}
}
?>
