<?php
define('PAGE_WIDTH', 612);
define('PAGE_HEIGHT', 792);
define('HEADER_HEIGHT', 100);
define('HEADER_TEXT', "PHP Unleashed");
define('HEADER_LOGO', "php-logo.jpg");
$pdf = pdf_new();
pdf_begin_document($pdf, "", "");
/*       */
$logo = pdf_open_image_file($pdf, "jpeg", "php-logo.jpg", null, null);
$logo_h = pdf_get_value($pdf, "imageheight", $logo);
/*    */
$template = pdf_begin_template($pdf, PAGE_WIDTH, HEADER_HEIGHT);
pdf_place_image($pdf, $logo, 5, (HEADER_HEIGHT-$logo_h)/2, 1.0);
$font = pdf_findfont($pdf, "Helvetica-Bold", "auto", false);
pdf_setfont($pdf, $font, 40);
$s_width = pdf_stringwidth($pdf, HEADER_TEXT, $font, 40);
pdf_show_xy($pdf, HEADER_TEXT, PAGE_WIDTH-$s_width - 10, 35);
pdf_end_template($pdf) ;
pdf_close_image($pdf, $logo);
for($i = 0; $i < 5; $i++) {
pdf_begin_page($pdf, PAGE_WIDTH, PAGE_HEIGHT);
pdf_place_image($pdf, $template, 0, PAGE_HEIGHT-80, 1.0);
pdf_end_page($pdf);
}
pdf_end_document($pdf, "");
$data = pdf_get_buffer($pdf);
header('Content-type: application/pdf');
header("Content-disposition: inline; filename=example1.pdf");
header("Content-length: " . strlen($data));
echo $data;
?>
